/*
** 堆排序的C++实现
** 假设：对N个整数进行升序排序
** HeapAdjust()函数用于调整大根堆
** 变量index为要调的整的父节点下标
** 变量j为要调整的子节点下标
*/
void HeapAdjust(vector<int>&seq, int index, int len){
    seq[0] = seq[index];    // 将要调整的结点的值存储到临时结点中
    for(int j = 2 * index; j <= len; j *= 2){ // 循环的调整父节点与子节点的位置关系，使堆满足定义
        if(j < len && seq[j] < seq[j + 1]) ++j;  // 选择子节点中较大的那一个
        if(seq[0] >= seq[j]) break;  // 当父节点大于等于两个子节点时，跳出
        seq[index] = seq[j];
        index = j;
    }
    seq[index] = seq[0];  // 将要移动的结点放到正确的位置
}

void HeapSort(vector<int>& seq){
    int i,length = seq.size();
    seq.insert(seq.begin(),0);  // 在序列最前面创建一个结点用来存储临时值
    for(i = length/2; i>0; i--)  // 选择最后一个非叶结点，构造大根堆
		HeapAdjust(seq, i, length);
    for(i = length; i>1; i--){  // 将根结点与无序序列的最后一个结点交换，并调整大根堆，重复这个步骤
        seq[1] ^= seq[i];
        seq[i] ^= seq[1];
        seq[1] ^= seq[i];
        HeapAdjust(seq, 1, i-1);
    }
    seq.erase(seq.begin()); // 删除临时结点
}