/*
** 归并排序的C++实现
** 假设：对N个数字进行升序排序
*/
void merge(int *data,int start,int end,int *result){
    int llen= (start+end)/2-start+1; // 左部分区间的数据元素的个数
    int lindex = start;
    int rindex = start + llen;
    int poinetr = start;
    while(lindex < start + llen && rindex < end+1){  // 分别对已经排好序的左区间和右区间进行合并
        if(data[lindex] <= data[rindex])
            result[poinetr++] = data[lindex++];
        else
            result[poinetr++] = data[rindex++];
    }
    while(lindex < start + llen)
        result[poinetr++] = data[lindex++];
    while(rindex < end+1)
        result[poinetr++] = data[rindex++];
}

void mergeSort(int *data, int start, int end, int *result){
    if(1 == end - start) {  //如果区间中只有两个元素，则对这两个元素进行排序
        if(data[start] > data[end]){
            data[start] ^= data[end];
            data[end] ^= data[start];
            data[start] ^= data[end];
        }
        return ;
    }
    else if(0 == end - start)   //如果只有一个元素，则不用排序
        return ;
    else{ // 继续划分子区间，分别对左右子区间进行排序
        mergeSort(data,start,(start+end)/2,result);
        mergeSort(data,(start+end)/2+1,end,result);
        merge(data,start,end,result);  // 归并已经排好序的start到end之间的数据
        for(int i = start;i <= end;++i) //把排序后的区间数据复制到原始数据中去
            data[i] = result[i];
    }
}