/*
** 桶排序算法的C++实现
** 假设：对N个数字进行升序排序
** 每个桶中的数据结构为：List-链表
*/
void bucketSort(vector<int>& seq){
    list<int> bucket[11]; // 定义桶的大小
    int min = seq[0],max=seq[0]; 
    for(int k=1;k<seq.size();k++) { //找到最大值最小值
        if(seq[k]<min) min=seq[k];
        if(seq[k]>max) max=seq[k];
    }
    int len = max - min;
    for(int i=0;i<seq.size();i++){
        bucket[(seq[i]*10)/len].push_back(seq[i]);  // 将数字按照映射放入桶中
    }
    for(int i=0;i<11;i++){
        bucket[i].sort(); // 分别对每个桶中的数字排序（这里调用了STL链表自身的排序算法）
    }
    seq.clear();
    for(int i=0;i<11;i++){
        while(bucket[i].size()){  // 将桶中的数字放回数组中
            seq.push_back(bucket[i].front());
            bucket[i].pop_front();
        }
    }
}