/*
** 直接插入排序的C++实现
** 假设：对N个数字进行升序排序
*/
void insertSort(vector<int>& seq) {
    int wait = seq[0] , j = 0;
    int length = seq.size(); // 待排序序列的长度
    for (int i = 1; i < length; i++) {
        if (seq[i] < seq[i - 1]) { // 当待插入元素小于前一个元素时
            wait = seq[i];  // 保存待插入的元素值到wait
            j = i - 1;
            while (wait < seq[j]) { // 依次将已排好序的元素与待插入元素比较
                seq[j + 1] = seq[j];  // 如果待排序元素小于当前元素，当前元素后移一位
                j--;
            }
            seq[j + 1] = wait;  // 将待排序元素插入到正确的位置
        }
    }
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

/*
** 二分插入排序的C++实现
** 每次采用折半查找的方式从已排好序的序列中定位插入位置
** 当high小于low时，查找结束，在high之后插入待排序的元素
*/

void insertSort2(vector<int>& seq) {
    int wait = seq[0];
    int length = seq.size(); // 待排序序列的长度
    for (int i = 1; i < length; i++) {
        if (seq[i] < seq[i - 1]) { // 当待插入元素小于前一个元素时
            wait = seq[i];  // 保存待插入的元素值到wait
            int low = 0, high = i - 1, mid = (high + low) / 2;
            /* 折半查找要插入的位置 */
            while (high >= low) {  // high小于low时终止查找
                if (wait < seq[mid])
                    high = mid - 1;
                else
                    low = mid + 1;
                mid = (high + low) / 2;
            }
            for (int j = i - 1; j > high; j--)
                seq[j + 1] = seq[j];  // 向后移动元素
            seq[high + 1] = wait; // 将待排序元素插入到正确的位置
        }
    }
}